import * as React from "react";
import { BigNumber } from "bignumber.js";
interface Props {
    dispatch: any;
    isRecovery?: boolean;
    walletTranslations: {
        [key: string]: any;
    };
    LocalWallet: any;
}
interface State {
    password: string;
    confirmation: string;
    isConfirm: boolean;
    processing: boolean;
    mnemonic: string;
    errorMsg: string | null;
    loading: boolean;
    addresses: {
        [key: string]: string;
    };
    balances: {
        [key: string]: BigNumber;
    };
    pathType: string;
    realPath: string;
    index: number;
    currentAddress: string | null;
    currentPage: number;
    gotoPageInputValue: number;
    currentPath: string;
}
declare class Create extends React.PureComponent<Props, State> {
    constructor(props: Props);
    componentDidUpdate(prevProps: Props, prevState: State): void;
    private submit;
    render(): JSX.Element;
    private renderRecoveryInput;
    private onLoadAddress;
    private loadAddresses;
    private getAddressOptions;
    selectAccount(address: string, path: string): void;
    private changePage;
    private gotoPageSubmit;
    private loadBalances;
    private renderFooter;
    private renderAddressSelection;
}
declare const _default: import("react-redux").ConnectedComponent<typeof Create, Pick<Props, "isRecovery">>;
export default _default;
