"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = {
    addFundsDesc: "There are multiple ways to add funds to your browser wallet. If you already have Wan Coins or Wrapped Wan Coins, simply transfer to your Wanchain DEX wallet's public address. If you do not already have Wan Coins, you can purchase some from a variety of platforms. We've linked a few for your convenience.",
    done: "Done",
    recoveryPhrase: "Recovery Phrase",
    testingDesc: "Please enter the correct words into the fields below to verify that you have recorded your recovery phrase.",
    backupDesc: "If you ever lose your computer, forget your password, change browsers or clear browsing data, you will need this recovery phrase to recover your wallet. Additionally, this phrase can be used to export your wallet to other applications. We recommend writing this down in multiple locations. DO NOT lose this recovery phrase: without it you could completely lose access to your wallet and funds.",
    next: "Next",
    confirmDesc: "Please read and confirm the important terms above on using your browser wallet.",
    create: "Create",
    createConfirm: [
        "I understand that my funds are held securely on this browser and not by Hydro Wallet.",
        "I will make sure to back up this wallet's Password in combination with its Recovery Phrase.",
        "I understand that if I cleared my browsing data (browsing history, cookies, cached images and files, etc.), my local wallet would be deleted.",
        "I understand that if I delete my browser wallet, I will have to import my wallet using this wallet's Recovery Phrase to recover wallet."
    ],
    password: "Password",
    confirm: "Confirm",
    confirmErrorMsg: "Confirmation must match",
    createDesc: "Once you click the Next button you will be taken through the wallet creation process. ***Please complete all four steps, or your wallet will NOT be created.***",
    dialogTitle: "Wanchain Wallet Selection",
    dialogSubtitle: "",
    selectWallet: "Select Wallet",
    close: "Close",
    unlock: "Unlock",
    headsUp: "headsUp",
    deleteTip: "Before you proceed, please make sure you have backed up your wallet. If you haven’t, you will permanently lose access to this wallet and all funds within it. Once you click Delete, the deletion will occur.",
    deleteConfirm: "I understand that I will lose all my assets in my wallet if I haven’t backed up this wallet.",
    delete: "Delete",
    createWallet: "Create Wallet",
    importWallet: "Import Wallet",
    deleteWallet: "Delete Wallet",
    selectAddress: "Select Address",
    extensionTip: "WanMask is a Chrome Extension Wallet, which can be download in chrome extension shop.",
    toggleButtonText: "Please Click to Select A Wallet",
    connectLedger: "Connect Ledger",
    connectTrezor: "Connect Trezor",
    currentWalletTypeNotSupported: "Current wallet type is not supported",
    noAvailableAddress: "No available address. (May be you need to unlock your wallet first)",
    pleaseSelectAddress: "Please select an address",
    clickToUpdateBalance: "Click to Update Address Balance",
    recoveryPhraseSpace: 'Recovery Phrase (12 words separated by space)',
    selectAddressOption: 'Select Address (option)',
    load: "Load",
    defaultAddress: "Default Address",
    selectPath: "Select Path",
    inputPath: "Input a path",
    installMetamask: "Install WanMask",
    installMetamaskDesc: 'WanMask browser extension currently runs on Google Chrome. For Safari users, please try other wallet options. <br/> Install WanMask from chrome web store <a target="_blank" rel="noopener noreferrer" href="https://chrome.google.com/webstore/detail/wanmask/omnkcjdohbnjfjmlaiboojplahajnenj?utm_source=chrome-ntp-icon">WanMask Install</a>',
    connectLedgerDesc: 'Ensure “Browser Support” and “Contract Data” is enabled within your device settings. <br/>Having issues still? Try reconnecting your Ledger or view Ledger Support.<a target="_blank" rel="noopener noreferrer" href="https://support.ddex.io/hc/en-us/articles/360001576533">Ledger Support</a>',
    connectTrezorDesc: 'Install Trezor bridge from trezor.io <a target="_blank" rel="noopener noreferrer" href="https://wallet.trezor.io/#/bridge">Trezor Bridge Download</a> <br/> Connect your Trezor wallet directly to your computer.',
    installLightWallet: "Install Wanchain Light Wallet",
    installLightWalletDesc: 'You can use wanchain light wallet for cross-chain and exchange. <br/>Download from Wanchain official site: <a target="_blank" rel="noopener noreferrer" href="https://wanchain.org/getstarted">Wanchain Light Wallet Download</a>'
};
