"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ethers_wan_1 = require("ethers-wan");
var providers_1 = require("ethers-wan/providers");
var baseWallet_1 = __importDefault(require("./baseWallet"));
var utils_1 = require("ethers-wan/utils");
var ethUtil = __importStar(require("ethereumjs-util"));
var web3_1 = __importDefault(require("web3"));
var WanWallet = (function (_super) {
    __extends(WanWallet, _super);
    function WanWallet(address, wallet) {
        var _this = _super.call(this) || this;
        _this._address = null;
        _this._wallet = null;
        _this._address = address.toLowerCase();
        if (wallet) {
            _this._wallet = wallet.connect(_this.getProvider());
        }
        return _this;
    }
    WanWallet.createRandom = function () {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, hydroWallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, ethers_wan_1.Wallet.createRandom()];
                    case 1:
                        wallet = _a.sent();
                        hydroWallet = new WanWallet(wallet.address, wallet);
                        return [2, hydroWallet];
                }
            });
        });
    };
    WanWallet.import = function (privateKey, password) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, hydroWallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, new ethers_wan_1.Wallet(privateKey)];
                    case 1:
                        wallet = _a.sent();
                        hydroWallet = new WanWallet(wallet.address, wallet);
                        return [4, hydroWallet.save(password)];
                    case 2:
                        _a.sent();
                        return [2, hydroWallet];
                }
            });
        });
    };
    WanWallet.fromMnemonic = function (mnemonic, password, path) {
        return __awaiter(this, void 0, void 0, function () {
            var wallet, hydroWallet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, ethers_wan_1.Wallet.fromMnemonic(mnemonic, path)];
                    case 1:
                        wallet = _a.sent();
                        hydroWallet = new WanWallet(wallet.address, wallet);
                        return [4, hydroWallet.save(password)];
                    case 2:
                        _a.sent();
                        return [2, hydroWallet];
                }
            });
        });
    };
    WanWallet.prototype.save = function (password) {
        return __awaiter(this, void 0, void 0, function () {
            var data, wallets, index;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._wallet || !this._address) {
                            return [2, false];
                        }
                        return [4, this._wallet.encrypt(password)];
                    case 1:
                        data = _a.sent();
                        wallets = WanWallet.getWalletData();
                        index = wallets.findIndex(function (json) { return WanWallet.parseWalletAddress(json) === _this._address; });
                        if (index !== -1) {
                            wallets.splice(index, 1, data);
                        }
                        else {
                            wallets.push(data);
                        }
                        WanWallet.setWalletData(wallets);
                        return [2, true];
                }
            });
        });
    };
    WanWallet.prototype.delete = function () {
        var _this = this;
        this._wallet = null;
        WanWallet._cache.delete(this._address);
        var wallets = WanWallet.getWalletData().filter(function (json) { return WanWallet.parseWalletAddress(json) !== _this._address; });
        WanWallet.setWalletData(wallets);
        return true;
    };
    WanWallet.setNodeUrl = function (nodeUrl) {
        if (nodeUrl) {
            this.nodeUrl = nodeUrl;
        }
    };
    WanWallet.prototype.type = function () {
        return WanWallet.TYPE;
    };
    WanWallet.prototype.id = function () {
        return WanWallet.TYPE + ":" + this._address;
    };
    WanWallet.list = function () {
        var _this = this;
        return this.getWalletData().map(function (json) {
            var wallet = _this.getWallet(_this.parseWalletAddress(json));
            return wallet;
        });
    };
    WanWallet.setWalletData = function (wallets) {
        localStorage.setItem(this.WALLETS_KEY, JSON.stringify(wallets));
    };
    WanWallet.getWalletData = function () {
        return JSON.parse(localStorage.getItem(this.WALLETS_KEY) || "[]");
    };
    WanWallet.parseWalletAddress = function (json) {
        return ethers_wan_1.utils.getAddress(JSON.parse(json).address).toLowerCase();
    };
    WanWallet.getWallet = function (address, _wallet) {
        var wallet = this._cache.get(address);
        if (!wallet || wallet._address !== address) {
            wallet = new WanWallet(address, _wallet);
            this._cache.set(address, wallet);
        }
        return wallet;
    };
    WanWallet.prototype.signMessage = function (message) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (!_this._wallet) {
                reject(baseWallet_1.default.NeedUnlockWalletError);
            }
            else {
                resolve(_this._wallet.signMessage(message));
            }
        });
    };
    WanWallet.prototype.signPersonalMessage = function (message) {
        return this.signMessage(ethUtil.toBuffer(message));
    };
    WanWallet.prototype.sendTransaction = function (txParams) {
        return __awaiter(this, void 0, void 0, function () {
            var tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (txParams.value) {
                            txParams.value = new utils_1.BigNumber(txParams.value);
                        }
                        if (!!this._wallet) return [3, 1];
                        return [2, Promise.reject(baseWallet_1.default.NeedUnlockWalletError)];
                    case 1: return [4, this._wallet.sendTransaction(txParams)];
                    case 2:
                        tx = _a.sent();
                        return [2, tx.hash];
                }
            });
        });
    };
    WanWallet.prototype.sendCustomRequest = function (method, params) {
        return __awaiter(this, void 0, void 0, function () {
            var tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this._provider) return [3, 1];
                        return [2, Promise.reject(baseWallet_1.default.NeedUnlockWalletError)];
                    case 1: return [4, this._provider.send(method, params)];
                    case 2:
                        tx = _a.sent();
                        return [2, tx];
                }
            });
        });
    };
    WanWallet.prototype.getAddresses = function () {
        var _this = this;
        return new Promise(function (resolve) {
            if (_this._address) {
                resolve([_this._address]);
            }
            else {
                resolve([]);
            }
        });
    };
    WanWallet.prototype.loadNetworkId = function () {
        return __awaiter(this, void 0, void 0, function () {
            var network;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._wallet || !this._wallet.provider) {
                            return [2];
                        }
                        return [4, this._wallet.provider.getNetwork()];
                    case 1:
                        network = _a.sent();
                        return [2, network.chainId];
                }
            });
        });
    };
    WanWallet.prototype.lock = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._wallet = null;
                return [2];
            });
        });
    };
    WanWallet.prototype.unlock = function (password) {
        return __awaiter(this, void 0, void 0, function () {
            var json, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        json = WanWallet.getWalletData().find(function (json) { return WanWallet.parseWalletAddress(json) === _this._address; });
                        _a = this;
                        return [4, ethers_wan_1.Wallet.fromEncryptedJson(json, password)];
                    case 1:
                        _a._wallet = _b.sent();
                        this._wallet = this._wallet.connect(this.getProvider());
                        this.resetTimeout();
                        return [2];
                }
            });
        });
    };
    WanWallet.prototype.isLocked = function () {
        return !this._wallet;
    };
    WanWallet.prototype.isSupported = function () {
        return true;
    };
    WanWallet.prototype.getProvider = function () {
        if (this._provider) {
            return this._provider;
        }
        if (WanWallet.nodeUrl.indexOf('ws') === 0) {
            this._provider = new providers_1.Web3Provider(new web3_1.default.providers.WebsocketProvider(WanWallet.nodeUrl));
            return this._provider;
        }
        this._provider = new providers_1.JsonRpcProvider(WanWallet.nodeUrl);
        return this._provider;
    };
    WanWallet.prototype.getMnemonic = function () {
        if (!this._wallet) {
            throw baseWallet_1.default.NeedUnlockWalletError;
        }
        this.resetTimeout();
        return this._wallet.mnemonic;
    };
    WanWallet.prototype.getPrivateKey = function () {
        if (!this._wallet) {
            throw baseWallet_1.default.NeedUnlockWalletError;
        }
        this.resetTimeout();
        return this._wallet.privateKey;
    };
    WanWallet.prototype.resetTimeout = function () {
        var _this = this;
        if (this._timer) {
            window.clearTimeout(this._timer);
        }
        this._timer = window.setTimeout(function () { return _this.lock(); }, WanWallet.TIMEOUT);
    };
    WanWallet.prototype.name = function () {
        return "Hydro Wallet";
    };
    WanWallet.TIMEOUT = 15 * 60 * 1000;
    WanWallet.WALLETS_KEY = "Wan-Wallets";
    WanWallet._cache = new Map();
    WanWallet.TYPE = "Wan-Wallet";
    WanWallet.LABEL = "Browser Wallet";
    return WanWallet;
}(baseWallet_1.default));
exports.default = WanWallet;
