import { BaseWallet } from ".";
import { txParams } from "./baseWallet";
declare global {
    interface Window {
        web3: any;
        alertAntd?: any;
    }
}
export default class LightWallet extends BaseWallet {
    static LABEL: string;
    static TYPE: string;
    currentAddress: string;
    type(): string;
    id(): string;
    loadNetworkId(): Promise<number>;
    signMessage(message: string | Uint8Array): Promise<string> | null;
    signPersonalMessage(message: string | Uint8Array): Promise<string>;
    sendTransaction(txParams: txParams): Promise<string | undefined>;
    sendCustomRequest(method: string, params?: any): Promise<any>;
    getAllAddresses(): Promise<string[]>;
    getAddresses(): Promise<string[]>;
    static enableBrowserExtensionWallet(): Promise<void>;
    isLocked(address: string | null): boolean;
    isSupported(): boolean;
    name(): string;
}
