"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Svg = (function (_super) {
    __extends(Svg, _super);
    function Svg() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Svg.prototype.render = function () {
        var _a = this.props, name = _a.name, size = _a.size;
        size = size ? size : "16";
        switch (name) {
            case "metamask":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", xmlns: "http://www.w3.org/2000/svg", width: size, height: size, viewBox: "0 0 16 16" },
                    react_1.default.createElement("image", { width: "16", height: "16", x: "0", y: "0", href: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAIAAAACACAMAAAD04JH5AAAABGdBTUEAALGPC/xhBQAAACBjSFJN\n            AAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAABpFBMVEX///8/vO0/vO0/vO0/\n            vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/\n            vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/\n            vO0/vO0/vO0/vO0Saas/vO0/vO0Saas/vO0/vO0/vO0/vO0Saas/vO0/vO0SaasSaasSaasSaasS\n            aasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasS\n            aasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasSaasS\n            aas/vO0/vO0/vO0SaasSaasSaas/vO0/vO0Saas/vO0SaasSaas/vO0/vO0/vO0/vO0/vO0/vO0/\n            vO0/vO0Saas/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/vO0/\n            vO0Saav///+KPakUAAAAiXRSTlMA5/lWdL3bJkaJpwgc92B4/dUeCu1ErZVinUwsvxLfw3qRDNka\n            UKFogzCZxamrowYYmc1qSteJKDp6blSLCBzb60BWcpOrwRQo6UZolamPw90aMkjTOiLRu5FwZkr7\n            5yoYx6+bOFgOWELxXnzfhQLFsccQy5tUNLt2Pq+XXOV+cgQWPLPTcPUCbOvJpqcAAAABYktHRACI\n            BR1IAAAAB3RJTUUH4woKEjshFnCzMQAAA6BJREFUeNrtm/dXFDEQxwMKiIroiQIiKIqCiqhYEAv2\n            ggV77wV7V+y9J3+1uywHe0cmySSZ7PO9/f7E7s3M53Ozd8e9x8KYUzjnbgPcUsHjVGaFn8KLmZoJ\n            n6eTMT68QhWfnOpw+Bouz7RAfA4nY3wIhVquy3RK/AwtPs5MMr4Rnu461BnzSRRmYfBR6kNtn80O\n            sQT1psmvwxwIUBgrmAsVNPjAz4Omz08VNUJFTcTbx9cR4YkUmqGRC6TlLVD5Qjt8KzSvDWxZBLW0\n            EG+f4DrYf7x4UaiHhiw2aG6CmtuJtz+RBqh/SRC844ylUGsHgq/46qL5dF4G9S1H4ePUQqM6ibfv\n            MM0v3mZil7R4hTWfsQ7pxJUY51UO+Djd6H2u9rN94DlVwXWip/jTGp/4EoW1xTPrhEQgyvhBb1y+\n            3hOfsQ3xuI1yVMlZITYVD/vqvOHjVG8u/tSfgCAB6UMeo6CIiWwhom9NMZQCNGvQAYQgVdCPzwVy\n            gVwgF8gFcoFc4H8V2JatwPaocCBDAXypV4Ed47U7sxDYVVK9O7iAcKx3FBCyhBPYI+TZG0hAwAkh\n            INShFtgndNlPKXBAi49zkEzACG/Ya1ExaMyXdTsLHMLgoxz2LIDE6wfgBCzwuhEYgX5LvhBHvAio\n            GQOGS7AWUM8/GlUMGSlYChyzGl6a4/YCJwzXq1M4aSmgnlr6Rj+lc8ULnDZ++knUH5SD2n7ce53J\n            4jgB0XyGyXM2jMA5Bud8AAGmDrUA04dS4IIBn7GLZAJGeOtZ/vCW0zQNl1B8xi77FbiCxMe56lHA\n            Ao8fCddes+Qzdt2HwA1rfJybzgJOeNRcGjxisqTolhe+/Gu1iUBy/jbvtia382H1cJXA2OnRP7sX\n            jJHp3EnfAoAVuJucrHS4k6DsLoR7GIH7yakHDvdSpG8CfpicemQsUP4UkjxG4Dvl942YCQxI8agl\n            gL1P9AJPk6NnDncUyVufJw/2aATGDl5wIBVa/EuotU8GKhNIHb6C5owo8a+htjcwavzskMkm1dfB\n            sOetVMB6nE294W+Zd9DE95LiD1DxRzOYPL3Q1JqyQvBl+8kFb75XmxeMRwVSfJRhaH7j6MOfoYe/\n            eOKz4v/1SdIKP33P/wXIsfGLj/IVhf/mnc+gW05laabAI64DFd5QgRIfpaDBfyfmR/mhwP+kx8fJ\n            avs6hXD4KCOT8L+C8qO0leB/h8bHyWr7kxX+ZMVn7G+E78oOH8f5G9c/FmRWkdMRBDsAAAAldEVY\n            dGRhdGU6Y3JlYXRlADIwMTktMTAtMTBUMTA6NTk6MzMrMDg6MDBcTb5lAAAAJXRFWHRkYXRlOm1v\n            ZGlmeQAyMDE5LTEwLTEwVDEwOjU5OjMzKzA4OjAwLRAG2QAAAABJRU5ErkJggg==" })));
            case "create":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", xmlns: "http://www.w3.org/2000/svg", width: size, height: size, viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { fill: "#666", fillRule: "evenodd", d: "M13.156 5.496c-.018-.006-.023-.028-.018-.017C10.885.1 3.175 1.221 2.452 7.037c0 0-1.147.267-1.876 1.345a3.384 3.384 0 0 0-.548 2.332c.104.84.53 1.559 1.132 2.068 2.075 1.752 2.555-.589 1.525-.963-2.33-.85-.48-4.472 1.504-2.839-1.573-5.37 6.608-7.779 7.73-2.014 2.275-.085 3.61 3.127 1.267 4.593-.842.527-.223 2.434 1.438.954 2.397-2.136 1.506-6.081-1.468-7.017m-2.14 4.914a.851.851 0 0 1 0 1.172l-2.83 2.933a1.56 1.56 0 0 1-2.261 0l-.942-.976c-.75-.775.383-1.948 1.13-1.172 1.152 1.192 1.066.849 3.773-1.957a.78.78 0 0 1 1.13 0" })));
            case "import":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", xmlns: "http://www.w3.org/2000/svg", width: size, height: size, viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { fill: "#666", fillRule: "evenodd", d: "M13.165 5.477c-.018-.006-.023-.028-.018-.017C10.9.11 3.209 1.225 2.487 7.01c0 0-1.144.265-1.872 1.337-2.306 3.394 2.618 6.457 2.618 4.309 0-.42-.063-.727-.514-.89-2.4-.872-.391-4.377 1.5-2.824-.788-2.684 1.18-5.31 3.802-5.31 1.957 0 3.554 1.48 3.91 3.307 2.266-.085 3.605 3.109 1.265 4.568-.878.548-.103 1.927.759 1.433 3.12-1.787 2.521-6.424-.79-7.463m-1.952 7.309v-.028l-.002.013.002.015m-.002-.015c-.008.448-.36.755-.795.755H8.819v1.65a.811.811 0 0 1-.798.824.812.812 0 0 1-.798-.825v-1.649H5.627c-.44 0-.798-.285-.798-.74v-.028c0-.456.357-.88.798-.88h1.596v-1.65c0-.456.357-.824.798-.824a.81.81 0 0 1 .798.824v1.65h1.597c.436 0 .787.443.795.893" })));
            case "delete":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", xmlns: "http://www.w3.org/2000/svg", width: size, height: size, viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { fill: "#666", fillRule: "evenodd", d: "M13.165 5.477c-.018-.006-.023-.028-.018-.017C10.9.11 3.209 1.225 2.487 7.01c0 0-1.144.265-1.872 1.337-2.306 3.394 2.618 6.457 2.618 4.309 0-.42-.063-.727-.514-.89-2.4-.872-.391-4.377 1.5-2.824-.788-2.684 1.18-5.31 3.802-5.31 1.957 0 3.554 1.48 3.91 3.307 2.266-.085 3.605 3.109 1.265 4.568-.878.548-.103 1.927.759 1.433 3.12-1.787 2.521-6.424-.79-7.463m-1.952 7.309v-.028l-.002.013.002.015m-.986 2.221c-.322.311-.788.28-1.096-.028l-1.13-1.129-1.165 1.166a.811.811 0 0 1-1.147.019.812.812 0 0 1 .018-1.147l1.166-1.167-1.128-1.128c-.312-.312-.363-.766-.041-1.088l.02-.02c.322-.322.875-.37 1.187-.058l1.128 1.128 1.166-1.166a.811.811 0 0 1 1.148-.018.81.81 0 0 1-.019 1.147l-1.166 1.166 1.13 1.13c.307.307.242.87-.07 1.193" })));
            case "logo":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", width: size, height: size, xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 16 16" },
                    react_1.default.createElement("g", null,
                        react_1.default.createElement("title", null, "Layer 1"),
                        react_1.default.createElement("g", { stroke: "null", fill: "#fff", id: "svg_12" },
                            react_1.default.createElement("g", { fill: "#fff", stroke: "null", transform: "matrix(0.08323892802615739,0,0,0.08268738295565478,-323.2631486270222,-252.59941803203154) ", id: "svg_5" },
                                react_1.default.createElement("g", { stroke: "null", fill: "#fff", id: "svg_6" },
                                    react_1.default.createElement("path", { stroke: "null", fill: "#fff", id: "svg_7", d: "m3971.376296,3202.788971l-73.8,0l0,-62.4l37.1,0l0,-14.1l-41.5,0c-5.3,0 -9.7,4.3 -9.7,9.7l0,71.2c0,5.3 4.3,9.7 9.7,9.7l80.1,0l0,-14.1c-0.8,0 -1.3,0 -1.7,0l-0.2,0z" })),
                                react_1.default.createElement("g", { stroke: "null", fill: "#fff", id: "svg_8" },
                                    react_1.default.createElement("path", { stroke: "null", id: "svg_9", d: "m4066.576296,3087.288971l-80.1,0l0,14.1c0.8,0 1.3,0 1.7,0l0.2,0l73.8,0l0,62.4l-37.1,0l0,14.1l41.5,0c5.3,0 9.7,-4.3 9.7,-9.7l0,-71.2c0,-5.4 -4.4,-9.7 -9.7,-9.7z" })),
                                react_1.default.createElement("g", { stroke: "null", fill: "#fff", id: "svg_10" },
                                    react_1.default.createElement("path", { stroke: "null", fill: "#fff", id: "svg_11", d: "m3996.676296,3126.388971l-28.9,0l0,-39.1l-4.4,0c-5.3,0 -9.7,4.3 -9.7,9.7l0,71.2c0,5.3 4.3,9.7 9.7,9.7l4.4,0l5.8,0l0,-14.1l-5.8,0l0,-23.3l24.5,0l0,76.5l4.4,0c5.3,0 9.7,-4.3 9.7,-9.7l0,-71.2c0,-5.4 -4.3,-9.7 -9.7,-9.7z" })))))));
            case "Gemini":
                return (react_1.default.createElement("svg", { width: "797.20001", height: "173.00002", viewBox: "0 0 210.92582 45.772921", version: "1.1", id: "svg1760" },
                    react_1.default.createElement("g", { id: "layer1", transform: "translate(309.17318,-194.34167)" },
                        react_1.default.createElement("g", { id: "g1811", transform: "translate(0.39688112,-0.39687465)" },
                            react_1.default.createElement("g", { style: { fill: "#000000" }, transform: "matrix(0.26458333,0,0,0.26458333,-309.17318,195.13542)", id: "g1774" },
                                react_1.default.createElement("path", { id: "path1762", d: "m 273.8,93.2 h 32.6 v 21.6 c -7,4.2 -16.5,6.8 -25.7,6.8 -23.2,0 -38.8,-15 -38.8,-37.4 0,-22.6 15.4,-37.8 38.2,-37.8 12.3,0 22.2,3.7 31.2,11.5 l 1.3,1.2 9.4,-15 -1,-0.8 c -11.9,-10 -25.4,-14.9 -41.1,-14.9 -15.9,0 -30.3,5.2 -40.6,14.7 -11,10.1 -16.8,24.3 -16.8,41 0,32.6 23.6,55.4 57.4,55.4 15.5,0 34.5,-6 45.1,-14.2 l 0.6,-0.5 V 76.1 h -51.7 v 17.1 z", style: { fill: "white" } }),
                                react_1.default.createElement("polygon", { id: "polygon1764", points: "432.9,138 432.9,120.8 366.7,120.8 366.7,90.8 421.6,90.8 421.6,73.6 366.7,73.6 366.7,47.1 432.9,47.1 432.9,29.9 348.3,29.9 348.3,138 ", style: { fill: "white" } }),
                                react_1.default.createElement("polygon", { id: "polygon1766", points: "555.1,29.9 513,80.5 471,29.9 454.1,29.9 454.1,138 473.2,138 473.2,61.1 510.7,106.3 515.2,106.3 552.7,61.1 552.7,138 571.8,138 571.8,29.9 ", style: { fill: "white" } }),
                                react_1.default.createElement("rect", { id: "rect1768", height: "108.1", width: "19.1", style: { fill: "white" }, y: "29.9", x: "599.90002" }),
                                react_1.default.createElement("polygon", { id: "polygon1770", points: "663.9,30.4 663.4,29.9 647,29.9 647,138 666.1,138 666.1,61.2 730.3,137.5 730.8,138 747.1,138 747.1,29.9 728,29.9 728,107 ", style: { fill: "white" } }),
                                react_1.default.createElement("rect", { id: "rect1772", height: "108.1", width: "19.1", style: { fill: "white" }, y: "29.9", x: "775.09998" })),
                            react_1.default.createElement("path", { id: "path1776", d: "m -279.77797,195.13542 c -7.91104,0 -14.63146,6.08542 -15.47813,13.91708 -7.83166,0.84667 -13.91708,7.56709 -13.91708,15.47813 0,8.59896 6.985,15.58396 15.58396,15.58396 7.91104,0 14.65791,-6.08542 15.47812,-13.91709 7.83167,-0.84666 13.91709,-7.56708 13.91709,-15.47812 0,-8.59896 -6.985,-15.58396 -15.58396,-15.58396 z m 11.93271,17.33021 c -0.7673,5.21229 -4.94771,9.39271 -10.16,10.16 v -10.16 z m -37.67667,10.31875 c 0.76729,-5.23875 4.94771,-9.41917 10.16,-10.18646 v 10.16 h -10.16 z m 23.86542,3.51896 c -0.87313,5.9002 -5.92667,10.29229 -11.93271,10.29229 -6.00604,0 -11.05959,-4.39209 -11.93271,-10.29229 z m 0.13229,-13.83771 v 10.29229 h -10.31875 v -10.29229 z m 13.67896,-3.51896 h -23.86542 c 0.87312,-5.90021 5.92667,-10.29229 11.93271,-10.29229 6.00604,0 11.05958,4.39208 11.93271,10.29229 z", style: { fill: "#00dcfa", strokeWidth: "0.26458332" } })))));
            case "ledger":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", xmlns: "http://www.w3.org/2000/svg", width: size, height: size, viewBox: "0 0 16 16" },
                    react_1.default.createElement("path", { fill: "#fff", fillRule: "nonzero", d: "M13.129.5H6.207v9.259h9.29v-6.85C15.5 1.609 14.432.5 13.128.5zM4.082.5H2.92C1.616.5.5 1.56.5 2.913V4.07h3.582V.5zM.5 6.238h3.582v3.57H.5v-3.57zm11.418 9.258h1.161c1.305 0 2.421-1.06 2.421-2.412V11.93h-3.582v3.566zm-5.71-3.566h3.581v3.57H6.207v-3.57zm-5.708 0v1.157c0 1.3 1.063 2.413 2.42 2.413h1.162v-3.57H.5z" })));
            case "trezor":
                return (react_1.default.createElement("svg", { className: "WanchainSDK-themeSvg", xmlns: "http://www.w3.org/2000/svg", width: size, height: size, viewBox: "0 0 16 16" },
                    react_1.default.createElement("image", { width: "16", height: "16", x: "0", y: "0", href: "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAHkAAACvCAMAAADuQ4FJAAAABGdBTUEAALGPC/xhBQAAACBjSFJN\n              AAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAUVBMVEW4j7Pb1tDb1tDb1tDb\n              1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb1tDb\n              1tDb1tDb1tD////6qH9mAAAAGXRSTlMAAzdikbLN4/oOgMCHQO6g2HB4GEggL1Opd2nW9wAAAAFi\n              S0dEGnVn5DIAAAAJcEhZcwAACxMAAAsTAQCanBgAAAAHdElNRQfjCxwTHioggfGaAAADjklEQVR4\n              2u2c65LiIBCFcw9oYjSZJPL+L7qacWqj0nAasHa2qs9v4RPCoTsinWVs5UVZ1U2rzE2qbeqqLDS/\n              Fz71cLwjN+xfqabr809yi6o1pE5D/yGsLhvj0fnygWnX48nH3QbeTWm5edki3I09phx34Z3npzn/\n              SjbgTnHANw1phj2zBvwY9pIAvHIHvEmV0eDRBJGNqSLBVRj2rmvUphYBNqaOQEeBY0Y9xoGDn3W+\n              xoKNuQSRl8BFvZcKCV/6HA82pg0IIJGr60c1G9ynARuzcpdXkrne5psZPS5An+rUItkCz1ra02Vb\n              lcs2Fr2slWd61MwhO/cQNRTPn14q5xflDNo1ZFVZjKIPDvMrhrNKupuGmLvpSLc54GQ6C6noIDCS\n              w27RyJHP5Lw5Mw06e4FTwgPVgyfFIdFD7GT7nldOrY8TON0T0f7obzoQTQt/04yOy8iOoIlXkREb\n              MxGlIG8Q8w1GLPtjPkE7f24fdIuR7SsU3AOJfRf62sQCwxZJNke0LuyTje5D9sgF5Qf2pQ1nNXZj\n              Qa9Z9uUJhzp7TgEZw94UdCS1G3ThZPit1E6GpkzIQhaykIX8q8n9q+wJYNeDsqdD17fP6cz8I81C\n              FrKQhSxkIQtZyEL+ZeR6SKIrn5zinwIZ+cuckIUsZCELWchCFrKQhSxkIQtZyEIWspCFLGQhC1nI\n              QhaykP8Pcpfkbqse+eQUV5ldl6adp4OqYl1QetXkvEPsOZdU1+DHPQ/uu4f+E9E66N58cfX1i5zF\n              Niv3lunX0d8rdgp8LhnsfIWuaqPnzy1aL0CX4K1D/OQbMpke4RoAnDN3r8mmDqp5wCd7TDZXrCu8\n              7P8ZUCZbvDaKJdtN1gM2iierV5NtNmJflg78V8fOZDlqozTkm8kOE9NGb2Tfzk7qZjKWjZ70bZKJ\n              Z4cdO7TdMGePlaIPod89QC+bob6EPi8u971wSugaZakt7YFn5e8HLLkCfV9/jnv8ypxRfrkmKN1g\n              UQ3cW2TGHER3G0EK3yDs3GrO4GwqfFN802ObxZXIZHD+tiOjOaRLrJz1SQEBfyd+nr6X/12BUti7\n              yV5BUfSeKiaoZDZx60pFvoPuBRYP+9Y9Cias3KbRAmJt0vJhmyCTnctPVMnLc9/LaZyNnOyscETR\n              Y7JSaXYthMmQKBgrSxSFo2CspudU9V4f5qMFEPfaparsKBirRxQNiIIJ2GsTHgVv+gOosjxLA+d7\n              ZgAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAxOS0xMS0yOVQwMjozMDo0Mi0wNzowMM41LzUAAAAldEVY\n              dGRhdGU6bW9kaWZ5ADIwMTktMTEtMjlUMDI6MzA6NDItMDc6MDC/aJeJAAAAAElFTkSuQmCC" })));
            case 'binance':
                return (react_1.default.createElement("svg", { x: "0px", y: "0px", height: "30px", viewBox: "0 0 632.014 126.611", "enable-background": "new 0 0 632.014 126.611" },
                    react_1.default.createElement("polygon", { fill: "#f5bc00", points: "38.171,53.203 62.759,28.616 87.36,53.216 101.667,38.909 62.759,0 23.864,38.896 " }),
                    react_1.default.createElement("rect", { x: "3.644", y: "53.188", transform: "matrix(0.7071 0.7071 -0.7071 0.7071 48.7933 8.8106)", fill: "#f5bc00", width: "20.233", height: "20.234" }),
                    react_1.default.createElement("polygon", { fill: "#f5bc00", points: "38.171,73.408 62.759,97.995 87.359,73.396 101.674,87.695 101.667,87.703 62.759,126.611 23.863,87.716 23.843,87.696 " }),
                    react_1.default.createElement("rect", { x: "101.64", y: "53.189", transform: "matrix(-0.7071 0.7071 -0.7071 -0.7071 235.5457 29.0503)", fill: "#f5bc00", width: "20.234", height: "20.233" }),
                    react_1.default.createElement("polygon", { fill: "#f5bc00", points: "77.271,63.298 77.277,63.298 62.759,48.78 52.03,59.509 52.029,59.509 50.797,60.742 48.254,63.285 48.254,63.285 48.234,63.305 48.254,63.326 62.759,77.831 77.277,63.313 77.284,63.305 " }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M148.37,30.679h31.117c7.723,0,13.563,1.982,17.521,5.946c3.063,3.07,4.594,6.875,4.594,11.414v0.192 c0,1.918-0.237,3.613-0.714,5.083c-0.476,1.472-1.112,2.797-1.907,3.98c-0.793,1.184-1.715,2.223-2.763,3.117 c-1.049,0.896-2.176,1.664-3.383,2.302c3.882,1.472,6.938,3.469,9.166,5.995c2.227,2.527,3.342,6.028,3.342,10.503v0.191 c0,3.07-0.59,5.755-1.771,8.058c-1.181,2.301-2.873,4.22-5.076,5.755c-2.203,1.535-4.852,2.685-7.948,3.453 c-3.096,0.767-6.527,1.15-10.292,1.15H148.37V30.679z M176.376,57.822c3.262,0,5.852-0.558,7.769-1.678 c1.918-1.119,2.877-2.926,2.877-5.419v-0.192c0-2.237-0.832-3.947-2.494-5.131c-1.663-1.183-4.061-1.775-7.193-1.775h-14.579v14.195 H176.376z M180.309,84.871c3.261,0,5.817-0.59,7.673-1.774c1.854-1.183,2.782-3.022,2.782-5.516V77.39 c0-2.238-0.864-4.012-2.59-5.324c-1.727-1.309-4.508-1.965-8.345-1.965h-17.073v14.771H180.309z" }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M223.875,30.679h14.772v67.141h-14.772V30.679z" }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M261.02,30.679h13.618l31.461,41.34v-41.34h14.579v67.141h-12.564l-32.516-42.682v42.682H261.02V30.679z" }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M365.398,30.2h13.619l28.776,67.62H392.35l-6.139-15.058h-28.391l-6.138,15.058h-15.061L365.398,30.2z M380.936,69.716l-8.921-21.772l-8.918,21.772H380.936z" }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M423.738,30.679h13.621l31.459,41.34v-41.34h14.579v67.141h-12.564l-32.516-42.682v42.682h-14.579V30.679z" }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M536.557,98.97c-4.926,0-9.496-0.896-13.717-2.685s-7.865-4.236-10.934-7.338 c-3.07-3.101-5.469-6.762-7.193-10.982c-1.727-4.221-2.59-8.729-2.59-13.525v-0.191c0-4.796,0.863-9.287,2.59-13.476 c1.725-4.188,4.123-7.865,7.193-11.03c3.068-3.165,6.746-5.66,11.029-7.482s9.018-2.733,14.197-2.733 c3.131,0,5.992,0.257,8.582,0.767c2.59,0.513,4.939,1.215,7.051,2.11c2.111,0.896,4.059,1.983,5.852,3.261 c1.787,1.28,3.451,2.686,4.986,4.221l-9.398,10.838c-2.625-2.365-5.293-4.221-8.01-5.563c-2.719-1.342-5.771-2.014-9.16-2.014 c-2.814,0-5.42,0.544-7.816,1.631c-2.398,1.087-4.461,2.589-6.188,4.507c-1.725,1.918-3.068,4.141-4.029,6.666 c-0.957,2.527-1.436,5.228-1.436,8.105v0.191c0,2.877,0.479,5.596,1.436,8.152c0.961,2.559,2.285,4.796,3.982,6.714 c1.693,1.918,3.74,3.438,6.137,4.557c2.4,1.12,5.037,1.678,7.914,1.678c3.838,0,7.08-0.703,9.734-2.11 c2.654-1.405,5.293-3.324,7.914-5.755l9.4,9.496c-1.727,1.855-3.52,3.518-5.371,4.987c-1.855,1.472-3.885,2.734-6.092,3.79 c-2.205,1.054-4.621,1.855-7.24,2.397C542.756,98.697,539.816,98.97,536.557,98.97z" }),
                    react_1.default.createElement("path", { fill: "#f5bc00", d: "M581.467,30.679h50.547v13.141h-35.967v13.62h31.652v13.14h-31.652v14.1h36.449v13.14h-51.029V30.679z" })));
            case 'huobi':
                return (react_1.default.createElement("svg", { width: "146px", height: "22px", viewBox: "0 0 146 22", version: "1.1" },
                    react_1.default.createElement("title", null, "\u706B\u5E01\u5168\u7EBF\u54C1\u724Clogo\u5BFC\u51FA-RGB_\u706B\u5E01Global-\u6807\u51C6\u8272"),
                    react_1.default.createElement("desc", null, "Created with Sketch."),
                    react_1.default.createElement("g", { id: "\u7EC4\u4EF6", stroke: "none", "stroke-width": "1", fill: "none", "fill-rule": "evenodd" },
                        react_1.default.createElement("g", { id: "\u5927\u5BA2\u6237\u6743\u76CA\u5BFC\u822A\u590D\u5236", transform: "translate(-64.000000, -13.000000)" },
                            react_1.default.createElement("g", { id: "\u7F16\u7EC4-16\u590D\u5236" },
                                react_1.default.createElement("g", { id: "\u7F16\u7EC4-9", transform: "translate(16.000000, 8.000000)" },
                                    react_1.default.createElement("g", { id: "\u706B\u5E01\u5168\u7EBF\u54C1\u724Clogo\u5BFC\u51FA-RGB_\u706B\u5E01Global-\u6807\u51C6\u8272", transform: "translate(48.000000, 5.000000)" },
                                        react_1.default.createElement("path", { d: "M27.102809,5.73155 L27.102809,11.9738667 L20.9432965,11.9738667 L20.9432965,6.53455 C20.9432965,6.09106667 20.5834322,5.73155 20.1397462,5.73155 L18.0607136,5.73155 L18.0607136,20.6070333 C18.0607136,21.0507 18.4203945,21.4102167 18.8642638,21.4102167 L20.9432965,21.4102167 L20.9432965,14.4914 L27.102809,14.4914 L27.102809,20.6070333 C27.102809,21.0507 27.4624899,21.4102167 27.9063593,21.4102167 L29.9852085,21.4102167 L29.9852085,6.53455 C29.9852085,6.09106667 29.6255276,5.73155 29.1816583,5.73155 L27.102809,5.73155", id: "Fill-1", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M39.1938467,9.42791667 L39.1938467,16.8576833 C39.1938467,17.5327167 38.8493894,18.1727333 38.2646558,18.5104333 C36.6324271,19.4531333 34.9433392,18.2755833 34.9433392,16.7229333 L34.9433392,10.2309167 C34.9433392,9.78743333 34.5836583,9.42791667 34.1397889,9.42791667 L32.0525025,9.42791667 L32.0525025,16.9876667 C32.0525025,19.4201333 34.043495,21.4102167 36.4770729,21.4102167 L37.6601131,21.4102167 C40.093691,21.4102167 42.0846834,19.4201333 42.0846834,16.9876667 L42.0846834,10.2309167 C42.0846834,9.78743333 41.7250025,9.42791667 41.2813166,9.42791667 L39.1938467,9.42791667", id: "Fill-2", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M71.2560704,21.4102167 L73.335103,21.4102167 L73.335103,10.8889 C73.335103,10.4452333 72.9752387,10.0857167 72.5315528,10.0857167 L70.4527035,10.0857167 L70.4527035,20.6070333 C70.4527035,21.0507 70.8123844,21.4102167 71.2560704,21.4102167", id: "Fill-3", fill: "#357CE1" }),
                                        react_1.default.createElement("path", { d: "M71.8938116,8.94556667 C72.7822839,8.94556667 73.5025628,8.22561667 73.5025628,7.33755 C73.5025628,6.44948333 72.7822839,5.72971667 71.8938116,5.72971667 C71.0053392,5.72971667 70.2852437,6.44948333 70.2852437,7.33755 C70.2852437,8.22561667 71.0053392,8.94556667 71.8938116,8.94556667", id: "Fill-4", fill: "#357CE1" }),
                                        react_1.default.createElement("path", { d: "M52.2285653,16.4352833 C52.2285653,17.8647333 51.0587312,18.8162333 49.6286281,18.8162333 C48.1985251,18.8162333 47.0285075,17.8647333 47.0285075,16.4352833 L47.0285075,14.3955167 C47.0285075,12.9660667 48.1985251,12.0145667 49.6286281,12.0145667 C51.0587312,12.0145667 52.2285653,12.9660667 52.2285653,14.3955167 L52.2285653,16.4352833 Z M49.6286281,9.42058333 L49.6286281,9.42058333 C46.6049975,9.42058333 44.1312513,11.58245 44.1312513,14.6045167 L44.1312513,16.2391167 C44.1312513,19.2611833 46.6049975,21.4102167 49.6286281,21.4102167 C52.6520754,21.4102167 55.126005,19.2611833 55.126005,16.2391167 L55.126005,14.6045167 C55.126005,11.58245 52.6520754,9.42058333 49.6286281,9.42058333 L49.6286281,9.42058333 Z", id: "Fill-5", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M65.3124397,16.4352833 C65.3124397,17.8647333 64.1424221,18.8162333 62.7123191,18.8162333 C61.2823995,18.8162333 60.1121985,17.8647333 60.1121985,16.4352833 L60.1121985,14.3955167 C60.1121985,12.9660667 61.2823995,12.0145667 62.7123191,12.0145667 C64.1424221,12.0145667 65.3124397,12.9660667 65.3124397,14.3955167 L65.3124397,16.4352833 Z M62.7123191,9.42058333 L62.7123191,9.42058333 C61.7673543,9.42058333 60.8763141,9.63178333 60.0975251,10.0144 L60.0975251,6.52116667 C60.0975251,6.0775 59.7376608,5.71798333 59.2939749,5.71798333 L57.2149422,5.71798333 L57.2149422,16.2391167 C57.2149422,19.2613667 59.6888719,21.4102167 62.7123191,21.4102167 C65.7359497,21.4102167 68.209696,19.2613667 68.209696,16.2391167 L68.209696,14.6045167 C68.209696,11.58245 65.7359497,9.42058333 62.7123191,9.42058333 L62.7123191,9.42058333 Z", id: "Fill-6", fill: "#357CE1" }),
                                        react_1.default.createElement("path", { d: "M122.788568,16.4849667 C122.788568,17.8995667 121.630656,18.84135 120.215226,18.84135 C118.79998,18.84135 117.641884,17.8995667 117.641884,16.4849667 L117.641884,14.4661 C117.641884,13.0515 118.79998,12.1097167 120.215226,12.1097167 C121.630656,12.1097167 122.788568,13.0515 122.788568,14.4661 L122.788568,16.4849667 Z M120.21541,9.5425 L120.215226,9.5425 C119.280166,9.5425 118.398113,9.75131667 117.627394,10.1299 L117.627394,6.52373333 C117.627394,6.08483333 117.271198,5.72898333 116.832098,5.72898333 L114.774525,5.72898333 L114.774525,16.2908167 C114.774525,19.2819 117.222776,21.4085667 120.215226,21.4085667 L120.21541,21.4085667 C123.207676,21.4085667 125.656111,19.2819 125.656111,16.2908167 L125.656111,14.6729 C125.656111,11.682 123.207676,9.5425 120.21541,9.5425 L120.21541,9.5425 Z", id: "Fill-7", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M141.801033,21.4085667 L141.801033,21.4085667", id: "Fill-8", fill: "#131322" }),
                                        react_1.default.createElement("path", { d: "M145.886465,21.35485 L145.886465,19.5457167 C145.886465,19.11745 145.539623,18.7707667 145.111161,18.7722333 C144.677746,18.7737 144.133915,18.7751667 143.674271,18.7751667 C142.50297,18.7751667 142.557812,18.1899667 142.557812,16.6727 L142.557812,6.51566667 C142.557812,6.08831667 142.211337,5.742 141.784158,5.742 L139.673761,5.742 L139.673761,17.0195667 C139.673761,19.7506833 140.378083,21.35485 143.327246,21.35485 C144.467,21.35485 145.293661,21.3225833 145.886281,21.3550333 L145.886465,21.35485", id: "Fill-9", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M90.6414221,12.0396833 L85.0637085,12.0396833 L85.0637085,13.5587833 C85.0637085,14.0154667 85.4340276,14.3856167 85.8907362,14.3856167 L88.540196,14.3856167 L88.540196,15.7287167 C88.540196,16.7196333 88.2925829,17.45095 87.7810327,17.9663 C87.1530126,18.6145667 86.283799,18.9570333 85.2680352,18.9570333 C84.3526005,18.9570333 83.4811859,18.6402333 82.9375377,18.10985 C82.1816759,17.3693667 82.0188015,16.5652667 82.0188015,13.5804167 C82.0188015,10.6126167 82.1816759,9.81218333 82.9371709,9.07243333 C83.4949422,8.52848333 84.5826055,8.1169 85.4842839,8.1169 C88.5334095,8.1169 89.5574271,9.19856667 90.3213593,10.1834333 L90.4213216,10.1834333 L90.4213216,7.98105 C90.4213216,7.65545 90.2657839,7.35111667 90.0113844,7.1478 C88.7340678,6.1259 87.4607864,5.75245 85.2680352,5.75245 C83.4971432,5.75245 81.9828518,6.30868333 80.7677136,7.40556667 C79.0896307,8.92008333 79.0898141,10.6289333 79.0901809,13.4599667 L79.0901809,13.7008667 C79.0898141,16.5319 79.0896307,18.2405667 80.7677136,19.7550833 C81.9659774,20.8369333 83.5222714,21.4085667 85.2680352,21.4085667 C87.1016558,21.4085667 88.7157261,20.79165 89.9356332,19.6247333 L89.936,19.6243667 C91.0245804,18.5793667 91.4686332,16.5781 91.4686332,14.4972667 L91.4686332,12.8663333 C91.4686332,12.4098333 91.0983141,12.0396833 90.6414221,12.0396833", id: "Fill-10", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M98.889505,21.4085667 L98.889505,21.4085667", id: "Fill-11", fill: "#131322" }),
                                        react_1.default.createElement("path", { d: "M99.7297387,21.35485 L99.7297387,19.5457167 C99.7297387,19.11745 99.382897,18.7707667 98.9544347,18.7722333 C98.5210201,18.7737 97.9771884,18.7751667 97.5175452,18.7751667 C96.3464271,18.7751667 96.4010854,18.1899667 96.4010854,16.6727 L96.4010854,6.51566667 C96.4010854,6.08831667 96.054794,5.742 95.6274322,5.742 L93.5170352,5.742 L93.5170352,17.0195667 C93.5170352,19.7506833 94.2213568,21.35485 97.1707035,21.35485 C98.3102739,21.35485 99.1369347,21.3225833 99.7295553,21.3550333 L99.7297387,21.35485", id: "Fill-12", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M109.825015,16.4849667 C109.825015,17.8995667 108.66692,18.84135 107.251673,18.84135 C105.836244,18.84135 104.678332,17.8995667 104.678332,16.4849667 L104.678332,14.4661 C104.678332,13.0515 105.836244,12.1097167 107.251673,12.1097167 C108.66692,12.1097167 109.825015,13.0515 109.825015,14.4661 L109.825015,16.4849667 Z M107.251673,9.5425 L107.251673,9.5425 C104.259224,9.5425 101.810789,11.682 101.810789,14.6729 L101.810789,16.2908167 C101.810789,19.2819 104.259224,21.4085667 107.251673,21.4085667 C110.244123,21.4085667 112.692374,19.2819 112.692374,16.2908167 L112.692374,14.6729 C112.692374,11.682 110.244123,9.5425 107.251673,9.5425 L107.251673,9.5425 Z", id: "Fill-13", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M134.757633,16.0372667 L134.757633,19.0146 C134.535148,19.0576833 134.289369,19.0919667 134.023231,19.11635 C133.37045,19.1777667 132.785166,19.18895 132.106156,19.1271667 C131.840384,19.10315 131.594972,19.0353167 131.376523,18.92715 C131.165593,18.8221 130.992997,18.6728667 130.849565,18.4704667 C130.713286,18.2787 130.644138,17.99545 130.644138,17.6286 C130.644138,17.05715 130.847915,16.64795 131.267756,16.3771667 C131.714377,16.0887833 132.391003,15.9423 133.279108,15.9423 C133.518651,15.9423 133.810467,15.95605 134.155291,15.9833667 C134.381078,16.0013333 134.582103,16.0193 134.757633,16.0372667 Z M136.300721,10.5508333 C135.445631,9.86828333 134.195827,9.52233333 132.585058,9.52233333 C131.986201,9.52233333 131.356897,9.56596667 130.71402,9.65176667 C130.198435,9.72051667 129.468802,9.81896667 128.962754,9.93556667 C128.75751,9.98286667 128.71991,10.1440167 128.71991,10.3370667 L128.71991,11.87615 C128.71991,12.1504167 128.722661,12.3999333 129.013193,12.3291667 C129.555191,12.1971667 130.606721,11.9643333 130.892118,11.9172167 C131.343874,11.8429667 131.835616,11.8055667 132.353585,11.8055667 C133.160437,11.8055667 133.775618,11.94985 134.18207,12.2334667 C134.563945,12.5007667 134.757633,13.0095167 134.757633,13.7454167 L134.757633,13.8345167 C134.614018,13.8213167 134.456279,13.8086667 134.284234,13.7971167 C133.96252,13.7754833 133.550198,13.7644833 133.047636,13.7644833 C132.361472,13.7644833 131.696585,13.8422167 131.072234,13.9956667 C130.438344,14.1518667 129.868467,14.3931333 129.378193,14.7134167 C128.879482,15.0401167 128.47945,15.4546333 128.189467,15.9467 C127.89655,16.44225 127.748349,17.0226833 127.748349,17.67095 C127.748349,18.3294833 127.875274,18.9027667 128.125638,19.3744833 C128.377837,19.8504167 128.740819,20.2473333 129.203214,20.5536833 C129.658455,20.8561833 130.217327,21.0772833 130.863688,21.21185 C131.492075,21.3423833 132.20355,21.4085667 132.978304,21.4085667 C133.542495,21.4085667 137.606834,21.3513667 137.606834,19.4181167 C137.606834,17.1779667 137.606834,13.8295667 137.606834,13.8295667 C137.606834,12.3465833 137.167367,11.2434667 136.300721,10.5508333 L136.300721,10.5508333 Z", id: "Fill-14", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M9.43002261,6.81981667 C9.43002261,3.69765 7.90839447,1.01273333 6.75103266,0.138416667 C6.74626382,0.135666667 6.66244221,0.08855 6.66959548,0.2134 L6.66794472,0.21725 C6.57183417,6.24543333 3.49079397,7.8793 1.79693719,10.0802167 C-2.11204774,15.1592833 1.52327889,20.72785 5.22518593,21.7570833 C7.29651508,22.3329333 4.74683417,20.7381167 4.41851759,17.36955 C4.0214196,13.2980833 9.43002261,10.1902167 9.43002261,6.81981667", id: "Fill-15", fill: "#D7E2F2" }),
                                        react_1.default.createElement("path", { d: "M11.2062337,8.87223333 C11.1825729,8.8561 11.1488241,8.8451 11.1255302,8.8836 C11.0618844,9.64241667 10.286397,11.26565 9.30346482,12.75615 C5.96967588,17.8119333 7.86951005,20.2491667 8.93773116,21.5581667 C9.55804774,22.3180833 8.93773116,21.5581667 10.4881558,20.7815667 C10.6095779,20.7207 13.5132538,19.0930667 13.8276307,15.3846 C14.132103,11.7934667 11.974201,9.52985 11.2062337,8.87223333", id: "Fill-16", fill: "#357CE1" }))))))));
            default:
                return null;
        }
    };
    return Svg;
}(react_1.default.PureComponent));
exports.default = Svg;
