"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var Input_1 = __importDefault(require("../Input"));
var wallet_1 = require("../../../actions/wallet");
var wallets_1 = require("../../../wallets");
var Select_1 = __importDefault(require("../Select"));
var bignumber_js_1 = require("bignumber.js");
var ethers_wan_1 = require("ethers-wan");
var react_paginate_1 = __importDefault(require("react-paginate"));
var mapStateToProps = function (state) {
    var walletState = state.WalletReducer;
    return {
        walletTranslations: walletState.get("walletTranslations"),
        LocalWallet: walletState.get("LocalWallet") || wallets_1.WanWallet
    };
};
var batchCount = 3;
var basePath = "m/44'/5718350'/0'/0";
var defaultPath = "m/44'/5718350'/0'/0/0";
var Create = (function (_super) {
    __extends(Create, _super);
    function Create(props) {
        var _this = _super.call(this, props) || this;
        _this.changePage = function (_a) {
            var selected = _a.selected;
            _this.setState({
                currentPage: selected,
                index: selected * batchCount
            });
        };
        _this.gotoPageSubmit = function (event) {
            event.preventDefault();
            var gotoPageInputValue = _this.state.gotoPageInputValue;
            var pageNumber = Number(gotoPageInputValue) - 1;
            _this.setState({
                currentPage: pageNumber,
                index: pageNumber * batchCount
            });
        };
        _this.state = {
            mnemonic: "",
            password: "",
            confirmation: "",
            isConfirm: true,
            processing: false,
            errorMsg: null,
            loading: false,
            pathType: basePath,
            realPath: basePath,
            index: 0,
            currentPage: 0,
            addresses: {},
            balances: {},
            currentAddress: null,
            gotoPageInputValue: 1,
            currentPath: defaultPath
        };
        _this.onLoadAddress = _this.onLoadAddress.bind(_this);
        return _this;
    }
    Create.prototype.componentDidUpdate = function (prevProps, prevState) {
        var _a = this.state, password = _a.password, confirmation = _a.confirmation, addresses = _a.addresses, index = _a.index;
        var _b = this.props, LocalWallet = _b.LocalWallet, isRecovery = _b.isRecovery;
        if ((password && confirmation && password !== prevState.password) || confirmation !== prevState.confirmation) {
            this.setState({ isConfirm: password === confirmation });
        }
        if (isRecovery) {
            if (LocalWallet != prevProps.LocalWallet || index != prevState.index) {
                this.loadAddresses();
            }
            if (addresses !== prevState.addresses) {
                this.loadBalances();
            }
        }
    };
    Create.prototype.submit = function (e) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, password, confirmation, mnemonic, currentPath, _b, dispatch, isRecovery, LocalWallet, wallet, wallet, e_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.state, password = _a.password, confirmation = _a.confirmation, mnemonic = _a.mnemonic, currentPath = _a.currentPath;
                        _b = this.props, dispatch = _b.dispatch, isRecovery = _b.isRecovery, LocalWallet = _b.LocalWallet;
                        e.preventDefault();
                        if (password !== confirmation) {
                            return [2];
                        }
                        this.setState({ processing: true });
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 6, , 7]);
                        if (!isRecovery) return [3, 3];
                        return [4, LocalWallet.fromMnemonic(mnemonic, password, currentPath)];
                    case 2:
                        wallet = _c.sent();
                        dispatch(wallet_1.watchWallet(wallet));
                        dispatch(wallet_1.setWalletStep(wallet_1.WALLET_STEPS.SELECT));
                        return [3, 5];
                    case 3: return [4, LocalWallet.createRandom()];
                    case 4:
                        wallet = _c.sent();
                        dispatch(wallet_1.cacheWallet(wallet, password));
                        dispatch(wallet_1.setWalletStep(wallet_1.WALLET_STEPS.BACKUP));
                        _c.label = 5;
                    case 5: return [3, 7];
                    case 6:
                        e_1 = _c.sent();
                        this.setState({ processing: false, errorMsg: e_1.message });
                        return [3, 7];
                    case 7: return [2];
                }
            });
        });
    };
    Create.prototype.render = function () {
        var _this = this;
        var _a = this.state, password = _a.password, confirmation = _a.confirmation, isConfirm = _a.isConfirm, processing = _a.processing;
        var walletTranslations = this.props.walletTranslations;
        return (React.createElement("form", { className: "WanchainSDK-form", onSubmit: function (e) { return _this.submit(e); } },
            this.renderRecoveryInput(),
            this.renderAddressSelection(),
            React.createElement(Input_1.default, { label: walletTranslations.password, text: password, handleChange: function (password) { return _this.setState({ password: password }); } }),
            React.createElement(Input_1.default, { label: walletTranslations.confirm, errorMsg: isConfirm ? "" : walletTranslations.confirmErrorMsg, text: confirmation, handleChange: function (confirmation) { return _this.setState({ confirmation: confirmation }); } }),
            React.createElement("div", { className: "WanchainSDK-desc" }, walletTranslations.createDesc),
            React.createElement("button", { className: "WanchainSDK-button WanchainSDK-submitButton WanchainSDK-featureButton", type: "submit", disabled: processing || !password || password !== confirmation },
                processing ? React.createElement("i", { className: "WanchainSDK-fa fa fa-spinner fa-spin" }) : null,
                " ",
                walletTranslations.next)));
    };
    Create.prototype.renderRecoveryInput = function () {
        var _this = this;
        var _a = this.state, mnemonic = _a.mnemonic, errorMsg = _a.errorMsg;
        var isRecovery = this.props.isRecovery;
        var walletTranslations = this.props.walletTranslations;
        var handleChange = function (mnemonic) {
            _this.setState({
                mnemonic: mnemonic,
                errorMsg: null
            });
        };
        if (!isRecovery) {
            return null;
        }
        return (React.createElement(Input_1.default, { label: walletTranslations.recoveryPhraseSpace, type: "text", text: mnemonic, errorMsg: errorMsg, handleChange: function (mnemonic) { return handleChange(mnemonic); } }));
    };
    Create.prototype.onLoadAddress = function (e) {
        var _this = this;
        e.preventDefault();
        this.setState({ loading: true }, function () { setTimeout(function () { _this.loadAddresses(); }, 0); });
    };
    Create.prototype.loadAddresses = function () {
        var _a = this.state, realPath = _a.realPath, index = _a.index, mnemonic = _a.mnemonic;
        var addresses = {};
        try {
            for (var i = index; i < index + batchCount; i++) {
                var path = realPath + "/" + i.toString();
                addresses[path] = ethers_wan_1.Wallet.fromMnemonic(mnemonic, path).address;
            }
            this.setState({ addresses: addresses });
        }
        catch (error) {
            this.setState({ errorMsg: error.message });
        }
        this.setState({ loading: false });
    };
    Create.prototype.getAddressOptions = function () {
        var _this = this;
        var _a = this.state, addresses = _a.addresses, balances = _a.balances;
        var addressOptions = [];
        Object.keys(addresses).map(function (path) {
            var address = addresses[path];
            var balance = balances[address];
            addressOptions.push({
                value: address,
                component: (React.createElement("div", { className: "WanchainSDK-address-option" },
                    React.createElement("span", null,
                        React.createElement("i", { className: "WanchainSDK-fa fa fa-check" }),
                        wallets_1.truncateAddress(address)),
                    React.createElement("span", null,
                        balance ? (balance.div("1000000000000000000").toFixed(5)) : (React.createElement("i", { className: "WanchainSDK-fa fa fa-spinner fa-spin" })),
                        " ",
                        "WAN"))),
                onSelect: function () {
                    _this.selectAccount(address, path);
                }
            });
        });
        return addressOptions;
    };
    Create.prototype.selectAccount = function (address, path) {
        this.setState({ currentAddress: address, currentPath: path });
    };
    Create.prototype.loadBalances = function () {
        var _this = this;
        var addresses = this.state.addresses;
        Object.keys(addresses).map(function (path) { return __awaiter(_this, void 0, void 0, function () {
            var balances, address, balance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        balances = this.state.balances;
                        address = addresses[path];
                        return [4, wallets_1.getBalance(address)];
                    case 1:
                        balance = _a.sent();
                        balances[address] = new bignumber_js_1.BigNumber(String(balance));
                        this.setState({ balances: balances });
                        this.forceUpdate();
                        return [2];
                }
            });
        }); });
    };
    Create.prototype.renderFooter = function () {
        var _this = this;
        var _a = this.state, currentPage = _a.currentPage, gotoPageInputValue = _a.gotoPageInputValue;
        return (React.createElement(React.Fragment, null,
            React.createElement(react_paginate_1.default, { key: currentPage, initialPage: currentPage, previousLabel: "<", nextLabel: ">", breakLabel: "...", pageCount: 10000, marginPagesDisplayed: 0, pageRangeDisplayed: 2, onPageChange: this.changePage, containerClassName: "WanchainSDK-pagination", breakClassName: "break-me", activeClassName: "active" }),
            React.createElement("div", { className: "WanchainSDK-paginationGotoPage" },
                "Go to page",
                React.createElement("form", { onSubmit: this.gotoPageSubmit },
                    React.createElement("input", { className: "WanchainSDK-input", type: "number", min: "1", step: "1", value: gotoPageInputValue, onChange: function (event) { return _this.setState({ gotoPageInputValue: parseInt(event.target.value, 10) }); } })))));
    };
    Create.prototype.renderAddressSelection = function () {
        var _this = this;
        var isRecovery = this.props.isRecovery;
        var walletTranslations = this.props.walletTranslations;
        var _a = this.state, loading = _a.loading, currentAddress = _a.currentAddress;
        if (!isRecovery) {
            return null;
        }
        var addressOptions = this.getAddressOptions();
        return (React.createElement("div", null,
            React.createElement("br", null),
            React.createElement("div", { className: "WanchainSDK-label" },
                walletTranslations.selectAddressOption,
                React.createElement("button", { type: "load", onClick: function (e) { return _this.onLoadAddress(e); }, style: {
                        width: "80px",
                        height: "21px",
                        margin: "0 0 0 14px",
                        fontSize: "12px", color: "#fff",
                        background: "linear-gradient(90deg,rgba(65,78,221,1) 0%,rgba(41,48,124,1) 100%)",
                        borderColor: "#555"
                    }, disabled: loading },
                    loading ? React.createElement("i", { className: "WanchainSDK-fa fa fa-spinner fa-spin" }) : null,
                    walletTranslations.load)),
            React.createElement(Select_1.default, { blank: walletTranslations.defaultAddress, noCaret: addressOptions.length === 0, disabled: addressOptions.length === 0, options: addressOptions, selected: !loading && currentAddress, footer: this.renderFooter() })));
    };
    return Create;
}(React.PureComponent));
exports.default = react_redux_1.connect(mapStateToProps)(Create);
