import * as React from "react";
export interface Option {
    value: any;
    text?: string;
    component?: any;
    onSelect?: any;
    hidden?: boolean;
    disabled?: boolean;
}
interface Props {
    options: Option[];
    selected: any;
    onSelect?: any;
    noCaret?: boolean;
    blank?: any;
    formatSelect?: any;
    disabled?: boolean;
    footer?: any;
}
interface State {
    unfolded: boolean;
}
export default class Select extends React.PureComponent<Props, State> {
    private container;
    private ps;
    constructor(props: Props);
    private tryFoldListener;
    componentDidMount(): void;
    componentDidUpdate(prevProps: Props): void;
    componentWillUnmount(): void;
    private switchFold;
    private setContainer;
    private getDropdownDirection;
    private renderDropdown;
    private renderOption;
    private renderSelected;
    private renderCaret;
    render(): JSX.Element;
}
export {};
